package com.bukkit.gemo.FalseBookIC;

import org.bukkit.Material;
import org.bukkit.block.*;
import org.bukkit.World;
import org.bukkit.entity.*;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockListener;
import org.bukkit.event.block.BlockRedstoneEvent;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.Location;

import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;

import com.bukkit.gemo.FalseBookIC.IC.*;

//Start the class BasicBlockListener
public class FalseBookICBlockListener extends BlockListener
{
	public static FalseBookICCore plugin;
	
	private static ArrayList<MC1110> TransmitterList = new ArrayList<MC1110>();
	private static ArrayList<MC0111> ReceiverList = new ArrayList<MC0111>();
	private static ArrayList<MCBlock> SensorList = new ArrayList<MCBlock>();
	
	// CONSTRUCTOR
	public FalseBookICBlockListener(FalseBookICCore instance)
	{
    	plugin = instance; 
	}	
			
	public void ExecuteHiddenSwitch(Block block)
	{
		Sign signBlock = (Sign)block.getState();
		
		final int dir = MCBlock.getDirection(signBlock);
		Block[] neighbours = new Block[8];
		neighbours[0] = block.getWorld().getBlockAt(block.getX(), block.getY() + 1, block.getZ());
		neighbours[1] = block.getWorld().getBlockAt(block.getX(), block.getY() - 1, block.getZ());
		if(dir == 2 || dir == 4)
		{
			neighbours[2] = block.getWorld().getBlockAt(block.getX(), block.getY(), block.getZ() + 1);
			neighbours[3] = block.getWorld().getBlockAt(block.getX(), block.getY(), block.getZ() - 1);
			neighbours[4] = block.getWorld().getBlockAt(block.getX(), block.getY()+1, block.getZ() + 1);
			neighbours[5] = block.getWorld().getBlockAt(block.getX(), block.getY()+1, block.getZ() - 1);
			neighbours[6] = block.getWorld().getBlockAt(block.getX(), block.getY()-1, block.getZ() + 1);
			neighbours[7] = block.getWorld().getBlockAt(block.getX(), block.getY()-1, block.getZ() - 1);	
		}
		else if(dir == 1 || dir == 3)
		{
			neighbours[2] = block.getWorld().getBlockAt(block.getX()+1, block.getY(), block.getZ());
			neighbours[3] = block.getWorld().getBlockAt(block.getX()-1, block.getY(), block.getZ());
			neighbours[4] = block.getWorld().getBlockAt(block.getX()+1, block.getY()+1, block.getZ());
			neighbours[5] = block.getWorld().getBlockAt(block.getX()-1, block.getY()+1, block.getZ());
			neighbours[6] = block.getWorld().getBlockAt(block.getX()+1, block.getY()-1, block.getZ());
			neighbours[7] = block.getWorld().getBlockAt(block.getX()-1, block.getY()-1, block.getZ());	
		}
		
		if(dir >= 1 && dir <= 4)
		{
			for(int i = 0; i < 8; i++)
			{
				if(neighbours[i].getType().equals(Material.LEVER))
				{
					int data = neighbours[i].getData();
					if ((data & 0x8) != 8)
	            	{
	            		data |= 8;
	            	}
		    		else if ((data & 0x8) == 8)	           
			    	{
			    		data ^= 8;		    		
			    	}
					neighbours[i].setData((byte)data);
				}
			}
		}		
	}
	
	// ON BLOCK BREAK
	@Override
	public void onBlockBreak(BlockBreakEvent event)
	{
		Block block = event.getBlock();
		if(block.getType().equals(Material.WALL_SIGN))
		{
			Sign sign = (Sign)block.getState();
			if(sign.getLine(1) != null)
			{
				// TRANSMITTER ?
				if(sign.getLine(1).equalsIgnoreCase("[MC1110]"))
				{
					for(int i = 0; i < TransmitterList.size(); i++)
					{
						MC1110 now = TransmitterList.get(i);
						if(now.getNetwork().equalsIgnoreCase(sign.getLine(2)))
						{
							if(now.getSignBlock().getX() == sign.getX() && now.getSignBlock().getY() == sign.getY() && now.getSignBlock().getZ() == sign.getZ())
							{
								TransmitterList.remove(i);
								saveTransmitter();
								return;
							}
						}
					}
				}
				// RECEIVER ?
				else if(sign.getLine(1).equalsIgnoreCase("[MC0111]"))
				{
					for(int i = 0; i < ReceiverList.size(); i++)
					{
						MC0111 now = ReceiverList.get(i);
						if(now.getNetwork().equalsIgnoreCase(sign.getLine(2)))
						{
							if(now.getSignBlock().getX() == sign.getX() && now.getSignBlock().getY() == sign.getY() && now.getSignBlock().getZ() == sign.getZ())
							{
								ReceiverList.remove(i);
								saveReceiver();
								return;
							}
						}
					}	
				}
				// POWER MC ?
				else if(sign.getLine(1).equalsIgnoreCase("[MC0020]")
						|| sign.getLine(1).equalsIgnoreCase("[MC0230]") 						
						|| sign.getLine(1).equalsIgnoreCase("[MC0260]") 
						|| sign.getLine(1).equalsIgnoreCase("[MC0261]") 
						|| sign.getLine(1).equalsIgnoreCase("[MC0262]")
						|| sign.getLine(1).equalsIgnoreCase("[MC0263]") 
						|| sign.getLine(1).equalsIgnoreCase("[MC0270]")
						|| sign.getLine(1).equalsIgnoreCase("[MC0271]")
						|| sign.getLine(1).equalsIgnoreCase("[MC0272]")
						|| sign.getLine(1).equalsIgnoreCase("[MC0420]")
						|| sign.getLine(1).equalsIgnoreCase("[MC2100]")
						|| sign.getLine(1).equalsIgnoreCase("[MC2101]"))
				{
					for(int i = 0; i < SensorList.size(); i++)
					{
						MCBlock now = SensorList.get(i);
						if(now.getSignBlock().getX() == sign.getX() && now.getSignBlock().getY() == sign.getY() && now.getSignBlock().getZ() == sign.getZ())
						{
							SensorList.remove(i);
							saveSensors();
							return;
						}
					}	
				}
			}
		}
		else if(!MCBlock.canPassThrough(block.getTypeId()))
		{
			World w = block.getWorld();
			Block[] blocks = new Block[4];
			blocks[0] = w.getBlockAt(block.getX()-1, block.getY(), block.getZ());
			blocks[1] = w.getBlockAt(block.getX()+1, block.getY(), block.getZ());
			blocks[2] = w.getBlockAt(block.getX(), block.getY(), block.getZ()-1);
			blocks[3] = w.getBlockAt(block.getX(), block.getY(), block.getZ()+1);
		
			for(int j = 0; j < 4; j++)
			{
				if(blocks[j].getType().equals(Material.WALL_SIGN))
				{
					//plugin.printInConsole("j:" + j);
					//plugin.printInConsole("signdata: " + ((Sign)blocks[j].getState()).getRawData());
					if(!((((Sign)blocks[j].getState()).getRawData() == 4 && j == 0)
						|| (((Sign)blocks[j].getState()).getRawData() == 5 && j == 1)
						|| (((Sign)blocks[j].getState()).getRawData() == 2 && j == 2)
						|| (((Sign)blocks[j].getState()).getRawData() == 3 && j == 3)
						))
					{
						return;
					}
					
					Sign sign = (Sign)blocks[j].getState();
					if(sign.getLine(1) != null)
					{
						// TRANSMITTER ?
						if(sign.getLine(1).equalsIgnoreCase("[MC1110]"))
						{
							for(int i = 0; i < TransmitterList.size(); i++)
							{
								MC1110 now = TransmitterList.get(i);
								if(now.getNetwork().equalsIgnoreCase(sign.getLine(2)))
								{
									if(now.getSignBlock().getX() == sign.getX() && now.getSignBlock().getY() == sign.getY() && now.getSignBlock().getZ() == sign.getZ())
									{
										TransmitterList.remove(i);
										saveTransmitter();
										return;
									}
								}
							}
						}
						// RECEIVER ?
						else if(sign.getLine(1).equalsIgnoreCase("[MC0111]"))
						{
							for(int i = 0; i < ReceiverList.size(); i++)
							{
								MC0111 now = ReceiverList.get(i);
								if(now.getNetwork().equalsIgnoreCase(sign.getLine(2)))
								{
									if(now.getSignBlock().getX() == sign.getX() && now.getSignBlock().getY() == sign.getY() && now.getSignBlock().getZ() == sign.getZ())
									{
										ReceiverList.remove(i);
										saveReceiver();
										return;
									}
								}
							}	
						}
						// POWER MC ?
						else if(sign.getLine(1).equalsIgnoreCase("[MC0020]")
								|| sign.getLine(1).equalsIgnoreCase("[MC0230]") 						
								|| sign.getLine(1).equalsIgnoreCase("[MC0260]") 
								|| sign.getLine(1).equalsIgnoreCase("[MC0261]") 
								|| sign.getLine(1).equalsIgnoreCase("[MC0262]")
								|| sign.getLine(1).equalsIgnoreCase("[MC0263]") 
								|| sign.getLine(1).equalsIgnoreCase("[MC0270]")
								|| sign.getLine(1).equalsIgnoreCase("[MC0271]")
								|| sign.getLine(1).equalsIgnoreCase("[MC0272]")
								|| sign.getLine(1).equalsIgnoreCase("[MC0420]")
								|| sign.getLine(1).equalsIgnoreCase("[MC2100]")
								|| sign.getLine(1).equalsIgnoreCase("[MC2101]"))
						{
							for(int i = 0; i < SensorList.size(); i++)
							{
								MCBlock now = SensorList.get(i);
								if(now.getSignBlock().getX() == sign.getX() && now.getSignBlock().getY() == sign.getY() && now.getSignBlock().getZ() == sign.getZ())
								{
									SensorList.remove(i);
									saveSensors();
									return;
								}
							}	
						}
					}
				}
			}
		}
	}

	public static int getTypeInt(String line)
	{
		for(int i = 0; i < MCBlock.MCList().size(); i++)
		{
			if(line.equalsIgnoreCase(MCBlock.MCList().get(i)))
			{
				return i;
			}
		}
		return -1;
	}
	
	// SCHILD PLATZIERUNG
	@Override
	public void onSignChange(SignChangeEvent event)
	{
		super.onSignChange(event);
		Player player = event.getPlayer();
		
		// STATION SCHILD?
		if(event.getLine(1).equalsIgnoreCase("[x]"))
		{
			if(!plugin.playerCanUseCommand(player, "*") && !plugin.playerCanUseCommand(player, "falsebook.blocks.hiddenswitch.create")&& !plugin.playerCanUseCommand(player, "falsebook.blocks.*"))
			{
				event.setCancelled(true);
				MCBlock.cancelCreation(event, "You are not allowed to build hidden switches.");
				return;
			}
		}
		
		// IS MC?
		final int thisMC = getTypeInt(event.getLine(1));		
		if(!event.getBlock().getType().equals(Material.WALL_SIGN) && thisMC > -1)
		{
			event.setCancelled(true);
			MCBlock.cancelCreation(event, "IC-Signs must be build on a wall.");
			return;
		}
		
		switch(thisMC)
		{
			case 0:
			{
				event.setLine(0, "RECEIVER");
				event.setLine(1, "[MC0111]");
				event.setLine(3, "");
				new MC0111(plugin, event, true);
				saveReceiver();
				break;
			}
			case 1: new MC1000(plugin, event, true); break;
			case 2: new MC1001(plugin, event, true); break;
			case 3:
			{
				event.setLine(0, "TRANSMITTER");
				event.setLine(1, "[MC1110]");
				event.setLine(3, "");
				new MC1110(plugin, event, true);
				saveTransmitter();
			    break;
			}
			case 4: new MC1200(plugin, event, true); break;
			case 5: new MC1201(plugin, event, true); break;
			case 6: new MC1020(plugin, event, true); break;
			case 7: new MC1017(plugin, event, true); break;
			case 8: new MC1018(plugin, event, true); break;
			case 9: new MC1205(plugin, event, true); break;
			case 10: new MC1206(plugin, event, true); break;
			case 11: new MC3002(plugin, event, true); break;
			case 12: new MC3003(plugin, event, true); break;
			case 13: new MC3020(plugin, event, true); break;
			case 14: new MC3021(plugin, event, true); break;
			case 15: new MC3030(plugin, event, true); break;
			case 16: new MC3033(plugin, event, true); break;
			case 17: new MC3031(plugin, event, true); break;
			case 18: new MC3034(plugin, event, true); break;
			case 19: new MC3036(plugin, event, true); break;
			case 20: new MC3040(plugin, event, true); break;
			case 21: new MC2020(plugin, event, true); break;
			case 22: new MC1230(plugin, event, true); break;
			case 23: new MC1231(plugin, event, true); break;
			case 24: new MC1260(plugin, event, true); break;
			case 25: new MC1261(plugin, event, true); break;
			case 26: new MC1262(plugin, event, true); break;
			case 27: new MC3231(plugin, event, true); break;
			case 28: new MC1025(plugin, event, true); break;
			case 29: new MC1240(plugin, event, true); break;
			case 30: new MC1241(plugin, event, true); break;
			case 31: new MC1270(plugin, event, true); break;
			case 32:
			{
				new MC0270(plugin, event, true);
				saveSensors();
				break;
			}
			case 33:
			{
				new MC0260(plugin, event, true);
				saveSensors();
				break;
			}
			case 34:
			{
				new MC0261(plugin, event, true);
				saveSensors();
				break;
			}
			case 35:
			{
				new MC0262(plugin, event, true);
				saveSensors();
				break;
			}
			case 36:
			{
				new MC0230(plugin, event, true);
				saveSensors();
				break;
			}
			case 37:
			{
				new MC0420(plugin, event, true);
				saveSensors();
				break;
			}
			case 38:
			{
				new MC0020(plugin, event, true);
				saveSensors();
				break;
			}
			case 39: new MC1207(plugin, event, true); break;
			case 40:
			{
				new MC0271(plugin, event, true);
				saveSensors();
				break;
			}
			case 41:
			{
				new MC0272(plugin, event, true);
				saveSensors();
				break;
			}
			case 42: new MC4000(plugin, event, true); break;
			case 43: new MC4010(plugin, event, true); break;
			case 44: new MC4100(plugin, event, true); break;
			case 45: new MC4110(plugin, event, true); break;
			case 46: new MC4200(plugin, event, true); break;
			case 47: new MC0263(plugin, event, true); break;
			case 48: new MC1271(plugin, event, true); break;
			case 49: new MC1272(plugin, event, true); break;
			case 50: new MC1263(plugin, event, true); break;
			case 51: new MC3000(plugin, event, true); break;
			case 52: new MC3001(plugin, event, true); break;
			case 53:
			{
				new MC2100(plugin, event, true);
				saveSensors(); 
				break;
			}
			case 54:
			{
				new MC2101(plugin, event, true); 
				saveSensors();
				break;
			}
			default: return;
		}
	}

	// REDSTONE EVENT
	@Override
	public void onBlockRedstoneChange(BlockRedstoneEvent event)
	{	
		// ntige Blcke einlesen
		Block block = event.getBlock();
		Location loc = block.getLocation();
		loc.setY(loc.getY() + 1);	

		int x = block.getX();
        int y = block.getY();
        int z = block.getZ();
		
        if(block.getWorld().getBlockAt(x+1,y,z).getType().equals(Material.WALL_SIGN))
        {
            signRedstoneEvent(block.getWorld(), x+1,y,z, event.getNewCurrent(), event);
        }
        if(block.getWorld().getBlockAt(x-1,y,z).getType().equals(Material.WALL_SIGN))
        {
            signRedstoneEvent(block.getWorld(), x-1,y,z, event.getNewCurrent(), event);
        }
        if(block.getWorld().getBlockAt(x,y,z+1).getType().equals(Material.WALL_SIGN))
        {
            signRedstoneEvent(block.getWorld(), x,y,z+1, event.getNewCurrent(), event);
        }
        if(block.getWorld().getBlockAt(x,y,z-1).getType().equals(Material.WALL_SIGN))
        {
            signRedstoneEvent(block.getWorld(), x,y,z-1, event.getNewCurrent(), event);
        }	
        if(block.getWorld().getBlockAt(x,y+1,z).getType().equals(Material.WALL_SIGN))
        {
            signRedstoneEvent(block.getWorld(), x,y+1,z, event.getNewCurrent(), event);
        }
	}
		
	// VERWALTUNG DES REDSTONE EVENTS
	public void signRedstoneEvent(World w, int x, int y, int z, int State, BlockRedstoneEvent event)
    {	
		if(w.getBlockAt(x,y,z).getType().equals(Material.WALL_SIGN))
		{
	        Sign signBlock = (Sign)w.getBlockAt(x,y,z).getState();
	        final int thisMC = getTypeInt(signBlock.getLine(1));		
			switch (thisMC)
			{
				case 1: MC1000.Execute(signBlock, State, event); break;
				case 2: MC1001.Execute(signBlock, State, event); break;
				case 3:
				{
					for(int i = 0; i < TransmitterList.size(); i++)
		        	{
		        		if(TransmitterList.get(i).getNetwork().equalsIgnoreCase(signBlock.getLine(2)))
		        		{
		        			TransmitterList.get(i).Execute(State, event);
		        		}
		        	} 
					break;
				}
				case 4: MC1200.Execute(signBlock, State, event); break;
				case 5: MC1201.Execute(signBlock, State, event); break;
				case 6: MC1020.Execute(signBlock, State, event); break;
				case 7: MC1017.Execute(signBlock, State, event); break;
				case 8: MC1018.Execute(signBlock, State, event); break;
				case 9: MC1205.Execute(signBlock, State, event); break;
				case 10: MC1206.Execute(signBlock, State, event); break;
				case 11: MC3002.Execute(signBlock, State, event); break;
				case 12: MC3003.Execute(signBlock, State, event); break;
				case 13: MC3020.Execute(signBlock, State, event); break;
				case 14: MC3021.Execute(signBlock, State, event); break;
				case 15: MC3030.Execute(signBlock, State, event); break;
				case 16: MC3033.Execute(signBlock, State, event); break;
				case 17: MC3031.Execute(signBlock, State, event); break;
				case 18: MC3034.Execute(signBlock, State, event); break;
				case 19: MC3036.Execute(signBlock, State, event); break;
				case 20: MC3040.Execute(signBlock, State, event); break;
				case 21: MC2020.Execute(signBlock, State, event); break;
				case 22: MC1230.Execute(signBlock, State, event); break;
				case 23: MC1231.Execute(signBlock, State, event); break;
				case 24: MC1260.Execute(signBlock, State, event); break;
				case 25: MC1261.Execute(signBlock, State, event); break;
				case 26: MC1262.Execute(signBlock, State, event); break;
				case 27: MC3231.Execute(signBlock, State, event); break;
				case 28: MC1025.Execute(signBlock, State, event); break;
				case 29: MC1240.Execute(signBlock, State, event); break;
				case 30: MC1241.Execute(signBlock, State, event); break;
				case 31: MC1241.Execute(signBlock, State, event); break;
				case 39: MC1207.Execute(signBlock, State, event); break;
				case 42: MC4000.Execute(signBlock, State, event); break;
				case 43: MC4010.Execute(signBlock, State, event); break;
				case 44: MC4100.Execute(signBlock, State, event); break;
				case 45: MC4110.Execute(signBlock, State, event); break;
				case 46: MC4200.Execute(signBlock, State, event); break;
				case 48: MC1271.Execute(signBlock, State, event); break;
				case 49: MC1272.Execute(signBlock, State, event); break;
				case 50: MC1263.Execute(signBlock, State, event); break;
				case 51: MC3000.Execute(signBlock, State, event); break;
				case 52: MC3001.Execute(signBlock, State, event); break;
				case 53: 
				{
					for(int i = 0; i < SensorList.size(); i++)
					{
						if(MCBlock.LocationEquals(signBlock.getBlock().getLocation(), SensorList.get(i).signBlock.getBlock().getLocation()))
						{
							((MC2100)SensorList.get(i)).Execute(signBlock, State, event);
							return;
						}
					}
					break;
				}
				case 54: 
				{
					for(int i = 0; i < SensorList.size(); i++)
					{
						if(MCBlock.LocationEquals(signBlock.getBlock().getLocation(), SensorList.get(i).signBlock.getBlock().getLocation()))
						{
							((MC2101)SensorList.get(i)).Execute(signBlock, State, event);
							return;
						}
					}
					break;
				}
				default: return;
			}
		}
    }	
	
	// GETTER
	public static ArrayList<MC1110> getTransmitterList()
	{
		return TransmitterList;
	}

	public static ArrayList<MC0111> getReceiverList()
	{
		return ReceiverList;
	}

	public static ArrayList<MCBlock> getSensorList()
	{
		return SensorList;
	}	
	
	
	// TRANSMITTER SPEICHERN
	  public void saveTransmitter()
	  {
	    File folder = new File("plugins/FalseBook");
	        folder.mkdirs();
	        
	        // TRANSMITTER SPEICHERN
	    try
	    {
	      ObjectOutputStream objOut = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream("plugins/FalseBook/Transmitter.db")));
	      String str = "";
	      for (int i = 0; i < TransmitterList.size(); i++)
	      {
	        MC1110 now = TransmitterList.get(i);
	        str = str + now.getSignBlock().getX()+ "," + now.getSignBlock().getY() + "," + now.getSignBlock().getZ()+ "," + now.getSignBlock().getWorld().getName() + ":";
	      }
	      objOut.writeObject(str);
	      objOut.close();   
	    }
	    catch (IOException e) 
	    {
	      plugin.printInConsole("Error while saving file: plugins/FalseBook/Transmitter.db");  
	      e.printStackTrace();        
	    } 
	  }
	  
	  // RECEIVER SPEICHERN
	  public void saveReceiver()
	  {
	    File folder = new File("plugins/FalseBook");
	        folder.mkdirs();
	        
	    // RECEIVER SPEICHERN
	    try
	    {
	      ObjectOutputStream objOut = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream("plugins/FalseBook/Receiver.db")));
	      String str = "";
	      for (int i = 0; i < ReceiverList.size(); i++)
	      {
	        str = str + ReceiverList.get(i).getSignBlock().getX()+ "," + ReceiverList.get(i).getSignBlock().getY() + "," + ReceiverList.get(i).getSignBlock().getZ()+ "," + ReceiverList.get(i).getSignBlock().getWorld().getName() + ":";
	        
	      }
	      objOut.writeObject(str);
	      objOut.close();   
	    }
	    catch (IOException e) 
	    {
	      plugin.printInConsole("Error while saving file: plugins/FalseBook/Receiver.db");  
	      e.printStackTrace();        
	    }   
	  }
	  
	  // MCs speichern
	  public static void saveSensors()
	  {
	    File folder = new File("plugins/FalseBook");
	        folder.mkdirs();
	        
	        // TRANSMITTER SPEICHERN
	    try
	    {
	      ObjectOutputStream objOut = new ObjectOutputStream(new BufferedOutputStream(new FileOutputStream("plugins/FalseBook/SensorList.db")));
	      String str = "";
	      int typ = -1;
	      for (int i = 0; i < SensorList.size(); i++)
	      {
	        MCBlock now = SensorList.get(i);
	        typ = -1;
	        if(now instanceof MC0270)
	          typ = 0;
	        else if(now instanceof MC0260)
	          typ = 1;
	        else if(now instanceof MC0261)
	          typ = 2;
	        else if(now instanceof MC0262)
	          typ = 3;
	        else if(now instanceof MC0230)
	          typ = 4;
	        else if(now instanceof MC0420)
	          typ = 5;
	        else if(now instanceof MC0020)
	          typ = 6;
	        else if(now instanceof MC0271)
	          typ = 7;
	        else if(now instanceof MC0272)
	          typ = 8;
	        else if(now instanceof MC0263)
	          typ = 9;
	        else if(now instanceof MC2100)
		      typ = 10;
	        else if(now instanceof MC2101)
		      typ = 11;
	        
	        str = str + typ + "," + now.getSignBlock().getX()+ "," + now.getSignBlock().getY() + "," + now.getSignBlock().getZ()+ "," + now.getSignBlock().getWorld().getName() + ":";
	      }
	      objOut.writeObject(str);
	      objOut.close();   
	    }
	    catch (IOException e) 
	    {
	      plugin.printInConsole("Error while saving file: plugins/FalseBook/SensorList.db");  
	      e.printStackTrace();        
	    } 
	  }
	  	  
	  // TRANSMITTER & RECEIVER LADEN
	  public static void loadWLAN()
	  {
	    loadTransmitter();
	    loadReceiver(); 
	    loadSensors();
	  }
	  
	  // TRANSMITTER LADEN
	  public static boolean loadTransmitter()
	  {
		TransmitterList.clear();
	    File f = new File("plugins/FalseBook/Transmitter.db");
	    if(!f.exists())
	    {
	      plugin.printInConsole("plugins/FalseBook/Transmitter.db not found.");
	      return false;
	    }
	        
	    try
	    {
	      ObjectInputStream objIn = new ObjectInputStream(new BufferedInputStream(new FileInputStream("plugins/FalseBook/Transmitter.db")));
	      String str = (String) objIn.readObject( );
	      objIn.close(); 
	      
	      String[] splitTrans = str.split(":");
	      for(int i = 0; i < splitTrans.length; i++)
	      {
	        String[] splitKoord = splitTrans[i].split(",");
	        if(splitKoord.length == 4)
	        {
	          int x = Integer.valueOf(splitKoord[0]); 
	          int y = Integer.valueOf(splitKoord[1]); 
	          int z = Integer.valueOf(splitKoord[2]); 
	          String w = splitKoord[3];
	          if(FalseBookICCore.server.getWorld(w) != null)
	          {  
	        	  new MC1110(plugin, x, y, z, w);
	          }
	        }   
	      }     
	      plugin.printInConsole(TransmitterList.size() + " Transmitters loaded.");    
	      return true;
	    }
	    catch (Exception e) 
	    {
	      plugin.printInConsole("Error while reading file: plugins/FalseBook/Transmitter.db");  
	      e.printStackTrace();  
	      return false;
	    } 
	  }
	  
	  // RECEIVER LADEN
	  public static boolean loadReceiver()
	  {
		ReceiverList.clear();
	    File f = new File("plugins/FalseBook/Receiver.db");
	    if(!f.exists())
	    {
	      plugin.printInConsole("plugins/FalseBook/Receiver.db not found.");
	      return false;
	    }
	        
	    try
	    {
	      ObjectInputStream objIn = new ObjectInputStream(new BufferedInputStream(new FileInputStream("plugins/FalseBook/Receiver.db")));
	      String str = (String) objIn.readObject( );
	      objIn.close(); 
	      
	      String[] splitTrans = str.split(":");
	      for(int i = 0; i < splitTrans.length; i++)
	      {
	        String[] splitKoord = splitTrans[i].split(",");
	        if(splitKoord.length == 4)
	        {
	          int x = Integer.valueOf(splitKoord[0]); 
	          int y = Integer.valueOf(splitKoord[1]); 
	          int z = Integer.valueOf(splitKoord[2]); 
	          String w = splitKoord[3]; 
	          if(FalseBookICCore.server.getWorld(w) != null)
	          {	   
	        	  new MC0111(plugin, x, y, z, w);
	          } 
	        }   
	      }     
	      plugin.printInConsole(ReceiverList.size() + " Receivers loaded.");    
	      return true;
	    }
	    catch (Exception e) 
	    {
	      plugin.printInConsole("Error while reading file: plugins/FalseBook/Receiver.db");  
	      e.printStackTrace(); 
	      return false;
	    } 
	  }
	  
	  // TRANSMITTER LADEN
	 public static boolean loadSensors()
	  {
		 SensorList = new ArrayList<MCBlock>();
	    File f = new File("plugins/FalseBook/SensorList.db");
	    
	    if(!f.exists())
	    {
	      plugin.printInConsole("plugins/FalseBook/SensorList.db not found.");
	      return false;
	    }
	        
	    try
	    {
	      ObjectInputStream objIn = new ObjectInputStream(new BufferedInputStream(new FileInputStream("plugins/FalseBook/SensorList.db")));
	      String str = (String) objIn.readObject( );
	      objIn.close(); 
	      
	      String[] splitTrans = str.split(":");
	      for(int i = 0; i < splitTrans.length; i++)
	      {
	        String[] splitKoord = splitTrans[i].split(",");
	        if(splitKoord.length == 5)
	        {
	          int typ = Integer.valueOf(splitKoord[0]); 
	          int x = Integer.valueOf(splitKoord[1]); 
	          int y = Integer.valueOf(splitKoord[2]); 
	          int z = Integer.valueOf(splitKoord[3]); 
	          String w = splitKoord[4];
	          
	          if(FalseBookICCore.server.getWorld(w) != null)
	          {         
			          if(typ == 0)
			            new MC0270(plugin, x, y, z, w); 
			          else if(typ == 1)
			            new MC0260(plugin, x, y, z, w);
			          else if(typ == 2)
			            new MC0261(plugin, x, y, z, w);
			          else if(typ == 3)
			            new MC0262(plugin, x, y, z, w);
			          else if(typ == 4)
			            new MC0230(plugin, x, y, z, w);
			          else if(typ == 5)
			            new MC0420(plugin, x, y, z, w);
			          else if(typ == 6)
			            new MC0020(plugin, x, y, z, w);
			          else if(typ == 7)
			            new MC0271(plugin, x, y, z, w);
			          else if(typ == 8)
			            new MC0272(plugin, x, y, z, w);
			          else if(typ == 9)
			            new MC0263(plugin, x, y, z, w);
			          else if(typ == 10)
			            new MC2100(plugin, x, y, z, w);
			          else if(typ == 11)
			            new MC2101(plugin, x, y, z, w);
	          }
	        }   
	      }     
	      plugin.printInConsole(SensorList.size() + " Sensors loaded.");    
	      return true;
	    }
	    catch (Exception e) 
	    {
	      plugin.printInConsole("Error while reading file: plugins/FalseBook/SensorList.db");  
	      e.printStackTrace();  
	      return false;
	    } 
	  }	
}
